<template>
  <div v-if="query" class="d-flex flex-grow-0 flex-column">
    <query-panel-selector/>
    <table-display-panel v-if="currentQueryPanel === 'table-display-panel'"
      :latitude="query.query.latitude"
      :longitude="query.query.longitude"/>
    <main-plot-panel v-if="currentQueryPanel === 'main-plot-panel'"
      :latitude="query.query.latitude"
      :longitude="query.query.longitude"/>
    <template v-if="query.query.isStation">
      <station-chart-panel v-if="currentQueryPanel === 'station-plot-panel'"
                           :station-id="query.query.stationId"/>
    </template>
    <skew-plot-panel v-if="currentQueryPanel === 'skewt-plot-panel'"
      :latitude="query.query.latitude"
      :longitude="query.query.longitude"/>
  </div>
</template>

<script>
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import QueryPanelSelector from '@/workspace/components/query/QueryPanelSelector'
import TableDisplayPanel from '@/workspace/components/query/TableDisplayPanel'
import SkewPlotPanel from '@/workspace/components/query/SkewPlotPanel'
import MainPlotPanel from '@/workspace/components/plots/MainPlotPanel'
import StationChartPanel from '@/workspace/components/query/StationChartPanel'

export default {
  name: 'WorkspaceQueryPanel',

  mixins: [
    WorkspaceGetter,
  ],

  computed: {
    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    currentQueryPanel: {
      get() {
        return this.query.ui.currentPanel
      }
    },
  },

  components: {
    TableDisplayPanel,
    MainPlotPanel,
    QueryPanelSelector,
    SkewPlotPanel,
    StationChartPanel,
  },
}
</script>
